// -*- C++ -*-
/*!
 * @file  RTC_E2_Crawler.cpp
 * @brief E2クローラ動作用RTC
 * @date $Date$
 *
 * @author AIZUK
 * kohno@aizuk.jp
 *
 * $Id$
 */

#include "RTC_E2_Crawler.h"
int time_FLG=0;
double t0=0,t1=0,sum_t=0;
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <curses.h>
#include <math.h>
#include <fstream>
#define degree		(180 / M_PI)
using namespace std;
//
//機体ステータス外部保存
//

ofstream Logout_M( "Velocity_SubDeg_Load_LOG.csv", ios::trunc );
ofstream Logout_V( "Main_LOG.csv", ios::trunc );
ofstream Logout_D( "Sub_LOG.csv", ios::trunc );
ofstream Logout_O( "Pose_LOG.csv", ios::trunc );
int FirstLoop=0;
int DegLoopR=0;
int DegLoopF=0;
int Vercity_FLG=0;
//////////////////////////
//SH通信用変数
//////////////////////////
char buf[512];
int SH_OK_FLG[5];
int SH_CONECT_FLG[5];
int SH1;
int SH2;
int SH3;
int MOT_MAIN_FLG=0;;
struct termios SH1_ter;
struct termios SH2_ter;
struct termios SH3_ter;
//////////////////////////
//モータ変数
//////////////////////////
typedef struct{
	int ENC[2];			//エンコーダ値
	int OLD_ENC[2];			//１周期前エンコーダ値
	int DEF_ENC[2];			//１周期前差分エンコーダ値
	
	float PWM[2];			//PWM
	float PWM_Order[2];		//PWM指令値
	double Velocity[2];		//現在速度 main 機体速度sub フリッパ角度
	double Velocity_Order[2];	//指令速度 main 機体角sub フリッパ角度
	double OLD_Velocity_Order[2];	//指令速度 main 機体角sub フリッパ角度
	double OLD_Velocity[2];	//指令速度 main 機体角sub フリッパ角度
	double int_Velocity[2];	//指令速度 main 機体角sub フリッパ角度
	
        double Deg[5];			//現在角度 main 機体姿勢(x,y,z)sub フリッパ角度
        double w[5];		//指令角度 main 機体姿勢指令(x,y,z)sub フリッパ角度指令
        double w_Order[5];		//指令角度 main 機体姿勢指令(x,y,z)sub フリッパ角度指令
        double DEF_Deg[5];		//現在角度 main 機体姿勢(x,y,z)sub フリッパ角度
        double Deg_T[5];		//指令角度 main 機体姿勢指令(x,y,z)sub フリッパ角度指令
        double Deg_Order[5];		//指令角度 main 機体姿勢指令(x,y,z)sub フリッパ角度指令
        double Old_deg[5];		//指令角度 main 機体姿勢指令(x,y,z)sub フリッパ角度指令
        
        float Load[2];			//モータ負荷
        float Verocity_MD[2];		//モータ回転数fromモータドライバ 精度激悪
        
}MOTOR_ST;
MOTOR_ST Main12;                	//メインモータ[1,2]=[右,左]
MOTOR_ST Sub34;                		//サブモータ[3,4]=前方[右,左]
MOTOR_ST Sub56;                		//サブモータ[5,6]=後方[右,左]
//////////////////////////
//ロボット変数
//	位置姿勢
//////////////////////////
typedef struct{
	double Vx;			//機体速度(x)
	double Vx_Order;		//機体速度(x)
	double Vy;			//機体速度(y)
	double Vy_Order;		//機体速度(y)
	double Vz;			//機体速度(z)
	double Vz_Order;		//機体速度(z)
        double Roll;			//外部データ機体姿勢Roll	Pose3DInより取得　信頼性は入力値による
        double Pitch;		//外部データ機体姿勢Pitch	Pose3DInより取得
        double Yaw;			//外部データ機体姿勢Yaw		Pose3DInより取得
        double Yaw_dt;		//外部データ機体姿勢Yaw		オドメトリより取得	信頼性：かなり低　クローラ滑る
        double X;			//外部データ機体位置X		Pose3DInより取得
        double Y;			//外部データ機体位置Y	　　　　　　　　Pose3DInより取得
        double Z;			//外部データ機体位置Z　　　　	Pose3DInより取得
        double X2;			//機体位置X
        double Y2;			//機体位置Y
        double Z2;			//機体位置Z
        double ODOM_X;		//オドメトリ機体位置X	信頼性：低
        double ODOM_Y;		//オドメトリ機体位置Y　	信頼性：低
        double ODOM_Z;		//オドメトリ機体位置Z	信頼性：低
        double ODOM_Yaw; 		//オドメトリ機体姿勢Yaw	信頼性：低
        double Sub_Deg[5];	//各フリッパ角度
        double Sub_w[5];		//各フリッパ角soku度
        double Va;			//オドメトリ機体加速度
        double Va_Order;		//機体加速度指令
        double Temp[3];			//機体姿勢(x,y,z)
}ROBOT_ST;
ROBOT_ST Robot;
int RPY_FLG=0;
/////////////////////////////
//サブクローラ
//角度指定系
/////////////////////////////
int Sub_LOCK[5]={0,0,0,0,0};

double dt=0;
// Module specification
// <rtc-template block="module_spec">
static const char* rtc_e2_crawler_spec[] =
  {
    "implementation_id", "RTC_E2_Crawler",
    "type_name",         "RTC_E2_Crawler",
    "description",       "E2クローラ動作用RTC",
    "version",           "1.0.0",
    "vendor",            "AIZUK",
    "category",          "Controller",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.BAUDRATE1", "B57600",
    "conf.default.BAUDRATE2", "B57600",
    "conf.default.BAUDRATE3", "B57600",
    "conf.default.SH1_PORT", "/dev/ttyUSB0",
    "conf.default.SH2_PORT", "/dev/ttyUSB1",
    "conf.default.SH3_PORT", "/dev/ttyUSB2",
    "conf.default.kp_R", "0.42",
    "conf.default.ki_R", "0.25",
    "conf.default.kd_R", "0.020",
    "conf.default.kp_L", "0.42",
    "conf.default.ki_L", "0.25",
    "conf.default.kd_L", "0.020",
    "conf.default.Rw", "0.07681",
    "conf.default.T", "0.3288",
    // Widget
    "conf.__widget__.BAUDRATE1", "radio",
    "conf.__widget__.BAUDRATE2", "radio",
    "conf.__widget__.BAUDRATE3", "radio",
    "conf.__widget__.SH1_PORT", "text",
    "conf.__widget__.SH2_PORT", "text",
    "conf.__widget__.SH3_PORT", "text",
    "conf.__widget__.kp_R", "text",
    "conf.__widget__.ki_R", "text",
    "conf.__widget__.kd_R", "text",
    "conf.__widget__.kp_L", "text",
    "conf.__widget__.ki_L", "text",
    "conf.__widget__.kd_L", "text",
    "conf.__widget__.Rw", "text",
    "conf.__widget__.T", "text",
    // Constraints
    "conf.__constraints__.BAUDRATE1", "(B9600,B14400,B19200,B38400,B57600)",
    "conf.__constraints__.BAUDRATE2", "(B9600,B14400,B19200,B38400,B57600)",
    "conf.__constraints__.BAUDRATE3", "(B9600,B14400,B19200,B38400,B57600)",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
RTC_E2_Crawler::RTC_E2_Crawler(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_Pose3DIn("Pose3D", m_Pose3D),
    m_Velocity_InIn("Velocity_In", m_Velocity_In),
    m_Sub_AngleIn("Sub_Angle", m_Sub_Angle),
    m_ModeIn("Mode", m_Mode),
    m_MOT_MainIn("MOT_Main", m_MOT_Main),
    m_MOT_SubIn("MOT_Sub", m_MOT_Sub),
    m_OdometryOut("Odometry", m_Odometry),
    m_Velocity_OutOut("Velocity_Out", m_Velocity_Out),
    m_LoadOut("Load", m_Load),
    m_Sub_Angle_OutOut("Sub_Angle_Out",m_Sub_Angle_Out)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
RTC_E2_Crawler::~RTC_E2_Crawler()
{
}



RTC::ReturnCode_t RTC_E2_Crawler::onInitialize()
{
  char str[512];
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("Pose3D", m_Pose3DIn);
  addInPort("Velocity_In", m_Velocity_InIn);
  addInPort("Sub_Angle", m_Sub_AngleIn);
  addInPort("Mode", m_ModeIn);
  addInPort("MOT_Main", m_MOT_MainIn);
  addInPort("MOT_Sub", m_MOT_SubIn);
  
  // Set OutPort buffer
  addOutPort("Odometry", m_OdometryOut);
  addOutPort("Velocity_Out", m_Velocity_OutOut);
  addOutPort("Load", m_LoadOut);
  addOutPort("Sub_Angle_Out",m_Sub_Angle_OutOut);
  
  // Set service provider to Ports
  
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("BAUDRATE1", m_BAUDRATE1, "B57600");
  bindParameter("BAUDRATE2", m_BAUDRATE2, "B57600");
  bindParameter("BAUDRATE3", m_BAUDRATE3, "B57600");
  bindParameter("SH1_PORT", m_SH1_PORT, "/dev/ttyUSB0");
  bindParameter("SH2_PORT", m_SH2_PORT, "/dev/ttyUSB1");
  bindParameter("SH3_PORT", m_SH3_PORT, "/dev/ttyUSB2");
  bindParameter("kp_R", m_kp_R, "0.042");
  bindParameter("ki_R", m_ki_R, "0.25");
  bindParameter("kd_R", m_kd_R, "0.02");
  bindParameter("kp_L", m_kp_L, "0.042");
  bindParameter("ki_L", m_ki_L, "0.25");
  bindParameter("kd_L", m_kd_L, "0.042");
  bindParameter("Rw", m_Rw, "0.07681");
  bindParameter("T", m_T, "0.3288");
  // </rtc-template>
    m_MOT_Main.data.length(11);
    m_MOT_Sub.data.length(11);  
    m_Sub_Angle.data.length(11);  
    m_Mode.data.length(11);  
    m_Load.data.length(11);
    m_Sub_Angle_Out.data.length(11);
///
///LOG
///
   ifstream STin( "Status.txt",ios::in );//SubAngle外部保存　読み込み
  if (STin.fail()){
         std::cerr << "失敗" << std::endl;
  }else{
  	  while (STin.getline(str, 512 - 1)){
		std::cout <<   str   << std::endl;
		sscanf(str,"%lf:%lf:%lf:%lf",&Sub34.Deg[0],&Sub34.Deg[1],&Sub56.Deg[0],&Sub56.Deg[1]);
		std::cerr<<"\x1b[1m" <<"\x1b[36m" << "Sub34" <<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
		std::cerr<<"\x1b[1m" <<"\x1b[36m" << Sub34.Deg[0] <<":"<< Sub34.Deg[1] <<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
		std::cerr<<"\x1b[1m" <<"\x1b[34m" << "Sub56" <<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
		std::cerr<<"\x1b[1m" <<"\x1b[34m" << Sub56.Deg[0] <<":"<< Sub56.Deg[1]<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	  }
	
  } 
  Main12.Velocity[0]=0;
  Main12.Velocity[1]=0;
  Main12.Velocity_Order[0]=0;
  Main12.Velocity_Order[1]=0;
  Main12.PWM_Order[0]=0;
  Main12.PWM_Order[1]=0;
  Robot.X=0;
  Robot.Y=0;
  Robot.Z=0;
  Robot.Yaw_dt=0;
  Log_init();
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onFinalize()
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onActivated(RTC::UniqueId ec_id)
{
 int i;
 for(i=0;i<=4;i++){
	SH_OK_FLG[i]=0;
 }
 FirstLoop=1;
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onDeactivated(RTC::UniqueId ec_id)
{
///////////////////////////////////////////////////////////////////////////////////
//終了処理 値は保持
//全モータ速度０に	
///////////////////////////////////////////////////////////////////////////////////

  close(SH1);
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onExecute(RTC::UniqueId ec_id)
{
        int i;
        int ret;
        double pre_PWM[2];
	char def1[1];
	char def2[1];
	char def3[1];
	char buf1[512];
	char buf2[512];
	char buf3[512];
	struct timeval ti;
//MODE 確認
	  if(m_ModeIn.isNew()){
		  	m_ModeIn.read();
		  	std::cerr<<"\x1b[1m" <<"\x1b[35m" <<m_Mode.data[0]
		  	<<m_Mode.data[1]<<m_Mode.data[2]<<m_Mode.data[3]<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
		
	}

//Velocity 確認
	if(m_Velocity_InIn.isNew()){//Velocity_In来てる
	  		m_Velocity_InIn.read();
	  		Robot.Vx_Order=m_Velocity_In.data.vx;
	  		Robot.Va_Order=m_Velocity_In.data.va;
	  		pre_PWM[0]=(m_Velocity_In.data.vx/m_Rw+m_Velocity_In.data.va*m_T/(2*m_Rw) );//*0.07681;
	  		pre_PWM[1]=(m_Velocity_In.data.vx/m_Rw-m_Velocity_In.data.va*m_T/(2*m_Rw) );//*0.07681;
	  		Main12.Velocity_Order[0]=-1*pre_PWM[0]*0.07681;
	  		Main12.Velocity_Order[1]=pre_PWM[1]*0.07681;
			Vercity_FLG=1;//Velocity_In来てるフラグ
	}else{
			Main12.PWM[0]=0;
		  	Main12.PWM[1]=0;
		  	Main12.Velocity_Order[0]=0;
		  	Main12.Velocity_Order[1]=0;
		  	Vercity_FLG=0;//Velocity_In来ていないフラグ
	}
	
	
//Sub_Angle 確認
	if(m_Sub_AngleIn.isNew()){
	  	m_Sub_AngleIn.read();
	  	std::cerr<<"\x1b[1m" <<"\x1b[35m" 
	  	<<m_Sub_Angle.data[0]<<m_Sub_Angle.data[1]
	  	<<m_Sub_Angle.data[2]<<m_Sub_Angle.data[3]
	  	<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	}
	
//MOT_Main確認
//Velocity_Inにデータが来ていない・繋がっていない時のみPWM直の値を採用
	if(Vercity_FLG!=1){//Velocity_In来ていない
		if(m_MOT_MainIn.isNew()){//MOT_Main来ている
		  	m_MOT_MainIn.read();
		  	Main12.PWM[0]=m_MOT_Main.data[0];
		  	Main12.PWM[1]=m_MOT_Main.data[1];
		  	MOT_MAIN_FLG=1;
		}else{
			Main12.PWM[0]=0;
		  	Main12.PWM[1]=0;
		  	MOT_MAIN_FLG=0;
		 }
	}else{
		MOT_MAIN_FLG=0;
	}
	
//MOT_Sub確認
	if(m_MOT_SubIn.isNew()){//MOT_SubIn.来てる
	  	m_MOT_SubIn.read();//m_Sub_Angleにデータ格納
	}else{
		m_MOT_Sub.data[0]=0;
		m_MOT_Sub.data[1]=0;
		m_MOT_Sub.data[2]=0;
		m_MOT_Sub.data[3]=0;
	}
	
	
//Pose3DIn確認
	if(m_Pose3DIn.isNew()){//Pose3D.来てる
		m_Pose3DIn.read();
	  	std::cerr<<"\x1b[1m" <<"\x1b[35m"
	  	<<" x:"
	  	<<m_Pose3D.data.position.x
	  	<<" y:"
	  	<<m_Pose3D.data.position.y
	  	<<" z:"
	  	<<m_Pose3D.data.position.z<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	  	std::cerr<<"\x1b[1m" <<"\x1b[35m"
	  	<<" x:"<<m_Pose3D.data.orientation.y
	  	<<" y:"<<m_Pose3D.data.orientation.p
	  	<<" z:"<<m_Pose3D.data.orientation.r<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
		//Robot.X = m_Pose3D.data.position.x;	//Rollデータ格納
	//	Robot.Y = m_Pose3D.data.position.y;	//Pitchデータ格納
	//	Robot.Z =  m_Pose3D.data.position.z;	//Yawデータ格納
		Robot.Roll = m_Pose3D.data.orientation.r;	//Rollデータ格納
		Robot.Pitch = m_Pose3D.data.orientation.p;	//Pitchデータ格納
		Robot.Yaw =  m_Pose3D.data.orientation.y;	//Yawデータ格納
	  	RPY_FLG=1;
	}else{
	  	 RPY_FLG=0;
	}
	
	
	
if(FirstLoop!=1){
//
//SH-1 Main Motor
//	Main12	
	Connect_serial(1);
	if(SH_OK_FLG[0]==1){
	
		memset(&buf1, 0, sizeof(buf1));
		memset(&def1, 0, sizeof(def1));
		
			if(SH_CONECT_FLG[0]==1){
		       		if(Main12.Velocity_Order[0]<0){
					Main12.PWM_Order[0] = -m_kp_R*(Main12.Velocity_Order[0]-Main12.Velocity[0])*100
								- m_ki_R*(Main12.int_Velocity[0])*100
								- m_kd_R*(Main12.Velocity_Order[0]-Main12.Velocity[0]-Main12.OLD_Velocity[0])*100+10;
				}else if(Main12.Velocity_Order[0]>0){
					Main12.PWM_Order[0] = -m_kp_R*(Main12.Velocity_Order[0]-Main12.Velocity[0])*100
								- m_ki_R*(Main12.int_Velocity[0])*100
								- m_kd_R*(Main12.Velocity_Order[0]-Main12.Velocity[0]-Main12.OLD_Velocity[0])*100-10;
				}else if(Main12.Velocity_Order[1]==0){
					Main12.PWM_Order[0] = 0;
					Main12.Velocity[0]=0;
					Main12.int_Velocity[0]=0;
					Main12.OLD_Velocity[0]=0;
//					Main12.OLD_ENC[0]=0;
					
				}
		       		if(Main12.Velocity_Order[1]<0){							
					Main12.PWM_Order[1] = -m_kp_L*(Main12.Velocity_Order[1]-Main12.Velocity[1])*100
								- m_ki_L*(Main12.int_Velocity[1])*100
								- m_kd_L*(Main12.Velocity_Order[1]-Main12.Velocity[1]-Main12.OLD_Velocity[1])*100+10;
				}else if(Main12.Velocity_Order[1]>0){							
					Main12.PWM_Order[1] =-m_kp_L*(Main12.Velocity_Order[1]-Main12.Velocity[1])*100
								- m_ki_L*(Main12.int_Velocity[1])*100
								- m_kd_L*(Main12.Velocity_Order[1]-Main12.Velocity[1]-Main12.OLD_Velocity[1])*100-10;
	          			}else if(Main12.Velocity_Order[1]==0){
		        	Main12.PWM_Order[1] =10; 
		        	Main12.Velocity[1]=0;
		        	Main12.int_Velocity[1]=0;
		        	Main12.OLD_Velocity[1]=0;
//		        	Main12.OLD_ENC[1]=0;
				}
			}	
			
			if(Main12.PWM_Order[0]>90)Main12.PWM_Order[0]=90;
			if(Main12.PWM_Order[0]<-90)Main12.PWM_Order[0]=-90;
			if(Main12.PWM_Order[1]>90)Main12.PWM_Order[1]=90;
			if(Main12.PWM_Order[1]<-90)Main12.PWM_Order[1]=-90;
		        
		sprintf(buf1,"s%.2f:%.2fe",(Main12.PWM_Order[0])*-1,(Main12.PWM_Order[1])*-1);
		if(MOT_MAIN_FLG==1)sprintf(buf1,"s%.2f:%.2fe",(Main12.PWM[0])*-1,(Main12.PWM[1]));
		//*-1+kp*(Main12.Velocity_Order[0]-Main12.Velocity[0])-kd*Main12.Velocity[0]/dt)
		//+kp*(Main12.Velocity_Order[1]-Main12.Velocity[1])-kd*Main12.Velocity[1]/dt) 
///	printf("%s\n\r",buf1);
		for(i=0;i<strlen(buf1);i++){
			def1[0]=buf1[i];
			ret=write(SH1,def1,sizeof(def1));
			if (ret == -1) {
				printf("ERROR\n\r");
			}
		}

		usleep(19000); 
		memset(&buf1, 0, sizeof(buf1));
		ret=read(SH1, buf1,80);
	printf("%s:size:%d\n\r",buf1, sizeof(buf1));
//	printf("size:%d\n\r",strlen(buf1));
		if (ret == -1||strlen(buf1)==0) {
			printf("ERROR\n\r");
			SH_CONECT_FLG[0]=0;
		}else{
			SH_CONECT_FLG[0]=1;
		//	printf("www\n\r");
		//s[20:-20][FFA:1DD0][0.015:2.908][2.043:1.241]ev
			
			sscanf(buf1,"s[%X:%X][%f:%f][%f:%f]e"
			,&Main12.ENC[0],&Main12.ENC[1],
			&Main12.Verocity_MD[1],&Main12.Load[1],
			&Main12.Verocity_MD[0],&Main12.Load[0]);
			//printf("1:%F 2:%F 3:%F 4:%F\n\r",Main12.Verocity_MD[1],Main12.Load[1],Main12.Verocity_MD[0],Main12.Load[0]);
			Main12.Load[0]=(Main12.Load[0]-2)*7/2;
			Main12.Load[1]=-(Main12.Load[1]-2)*7/2;
	
			Main12.DEF_ENC[0]=Main12.ENC[0]-Main12.OLD_ENC[0];
	
	//		std::cout<<"sE1:"<gyt<Main12.ENC[0]<<"sE2:"<<Main12.ENC[1]<<std::endl;
			if(Main12.DEF_ENC[0] <= -50000){
				Main12.DEF_ENC[0]=Main12.ENC[0]+65535-Main12.OLD_ENC[0];
			}		
			if(Main12.DEF_ENC[0] >= 50000){
				Main12.DEF_ENC[0]=Main12.ENC[0]-65535-Main12.OLD_ENC[0];
			}
			
	//		std::cout<<"sL1:"<<Main12.DEF_ENC[0]<<std::endl;
			
		        Main12.w[0]=(Main12.DEF_ENC[0]*4*M_PI)/(500*dt);
	//		std::cout<<"w1:"<< Main12.w[0]<<std::endl;
		        Main12.Velocity[0]=-Main12.w[0]*0.07681/1000;
		        /////////////////////////////////////////////////////////////
		        
	
			Main12.DEF_ENC[1]=Main12.ENC[1]-Main12.OLD_ENC[1];
	
			if(Main12.DEF_ENC[1] <= -50000){
				Main12.DEF_ENC[1]=Main12.ENC[1]+65535-Main12.OLD_ENC[1];
			}		
			if(Main12.DEF_ENC[1] >= 50000){
				Main12.DEF_ENC[1]=Main12.ENC[1]-65535-Main12.OLD_ENC[1];
			}
			
			
			std::cout<<"DE0:"<<Main12.DEF_ENC[0]<<std::endl;
			std::cout<<"DE1:"<<Main12.DEF_ENC[1]<<std::endl;
		        Main12.w[1]=(-Main12.DEF_ENC[1]*4*M_PI)/(500*dt);
		        Main12.Velocity[1]=Main12.w[1]*0.07681/1000;
		        ////////////////////////////////////////////////////////////
		        Robot.Vx=(-Main12.Velocity[0]+Main12.Velocity[1])/2;
		        Robot.Va=(-Main12.Velocity[0]-Main12.Velocity[1])/m_T;
		        Robot.Yaw_dt += Robot.Va*dt;
		        if( RPY_FLG == 1){
					//m_Pose3D.data.orientation.p;
					//m_Pose3D.data.orientation.r;
				Robot.Z=// G_Global[2]*( cos(roll*rad)*cos(pitch*rad))
			    	      // + G_Global[1]*(cos(roll*rad)*sin(pitch*rad)*sin(yaw*rad) - (sin(roll*rad)*cos(yaw*rad)))
				     (   Robot.Vx*(cos(Robot.Roll)*sin(Robot.Pitch)
				     *cos(Robot.Yaw)
				       + sin(Robot.Roll)
				       *sin(Robot.Yaw) )) *dt +Robot.Z;

				Robot.Y=//  G_Global[2]*(sin(roll*rad)*cos(pitch*rad))
			    	      // + G_Global[1]*(sin(roll*rad)*sin(pitch*rad)*sin(yaw*rad) + (cos(roll*rad)*cos(yaw*rad)))
				     (  Robot.Vx*(sin(Robot.Roll)*sin(Robot.Pitch)
				     * cos(Robot.Yaw) 
				     - (cos(Robot.Roll)*sin(Robot.Yaw))))*dt+Robot.Y;
				       
				Robot.X= // G_Global[2]*(-sin(pitch*rad) )
				      //+  G_Global[1]*(sin(pitch*rad)*sin(yaw*rad) )
				      (  Robot.Vx*(cos(Robot.Pitch)
				      *cos(Robot.Yaw) ) ) *dt  +Robot.X;
				      
			        Robot.X2=Robot.Vx*cos(Robot.Yaw)*dt+Robot.X2;
			        Robot.Y2=Robot.Vx*sin(Robot.Yaw)*dt+Robot.Y2;
			        
				m_Odometry.data.position.x=Robot.X;
				m_Odometry.data.position.y=Robot.Y;
				m_Odometry.data.position.z=Robot.Z;
				m_Odometry.data.orientation.y=Robot.Yaw;
				m_Odometry.data.orientation.p=Robot.Pitch;
				m_Odometry.data.orientation.r=Robot.Roll; 
				m_OdometryOut.write();
			      
		        }else{
		                
			        Robot.X2=Robot.Vx*cos(Robot.Yaw_dt)*dt+Robot.X2;
			        Robot.Y2=Robot.Vx*sin(Robot.Yaw_dt)*dt+Robot.Y2;
				m_Odometry.data.position.x=Robot.X2;
				m_Odometry.data.position.y=Robot.Y2;
				m_Odometry.data.position.z=0;				//z方向への移動（地面鉛直↑向き）計算不可
				m_Odometry.data.orientation.y=Robot.Yaw_dt;
				m_Odometry.data.orientation.p=0;			//pitch計算不可
				m_Odometry.data.orientation.r=0; 			//roll計算不可
				m_OdometryOut.write();
			
			}
		        m_Velocity_Out.data.vx=Robot.Vx;
		        m_Velocity_Out.data.va=Robot.Va;
		        m_Velocity_OutOut.write();

			Main12.DEF_Deg[0]=Main12.DEF_ENC[0]*0.00133;//1:135 モータ1回転500パルス
			Main12.Deg[0] += Main12.DEF_Deg[0];
			Main12.OLD_ENC[0]=Main12.ENC[0];
			
			Main12.DEF_Deg[1]=Main12.DEF_ENC[1]*0.00133;//1:135 モータ1回転500パルス
			Main12.Deg[1] += Main12.DEF_Deg[1];
			Main12.OLD_ENC[1]=Main12.ENC[1];
			
		        Main12.OLD_Velocity[0]= Main12.Velocity_Order[0]-Main12.Velocity[0];
		        Main12.OLD_Velocity[1]= Main12.Velocity_Order[1]-Main12.Velocity[1];
		        Main12.int_Velocity[0]+= Main12.Velocity_Order[0]-Main12.Velocity[0];
		        Main12.int_Velocity[1]+= Main12.Velocity_Order[1]-Main12.Velocity[1];
		        Main12.OLD_Velocity_Order[0]=Main12.Velocity_Order[0];
		        Main12.OLD_Velocity_Order[1]=Main12.Velocity_Order[1];
		}
	
	}
	close(SH1);
	
	
//
//SH-2 Sub Motor
//	Sub34
 Connect_serial(2);

	if(SH_OK_FLG[1]==1){
		memset(&buf2, 0, sizeof(buf2));
		memset(&def2, 0, sizeof(def2));
	//
	//指令値生成 from MOT
	//
		Sub34.Deg_Order[0]= (int)m_MOT_Sub.data[0];
		Sub34.Deg_Order[1]= (int)m_MOT_Sub.data[1];
		if(m_Mode.data[3]==1||Sub_LOCK[0]==1||Sub_LOCK[1]==1){
			if(m_Sub_Angle.data[0]!=555|| (Sub_LOCK[0]==1)){
				if(m_Sub_Angle.data[0]!=555){			
				        Sub34.Deg_T[0]=m_Sub_Angle.data[0];
				}
				Sub_LOCK[0]=1;
				Sub_ANG(0,Sub34.Deg_T[0]);
			}else{
			//	Sub_LOCK[0]=0;
			}

			if(m_Sub_Angle.data[1]!=555|| (Sub_LOCK[1]==1)){
			        if(m_Sub_Angle.data[1]!=555){			
				        Sub34.Deg_T[1]=m_Sub_Angle.data[1];
				}
				Sub_LOCK[1]=1;
				Sub_ANG(1,Sub34.Deg_T[1]);
				
			}else{			
			//	Sub_LOCK[1]=0;
			}

			//std::cout<<"sL1:"<<Sub_LOCK[0]<<"sL2:"<<Sub_LOCK[1]<<std::endl;
		}
		
		

	//	std::cout<<"s1:"<<Sub34.Deg_Order[0]<<"s2:"<<Sub34.Deg_Order[1]<<std::endl;
		sprintf(buf2,"s%d:%de",(int)Sub34.Deg_Order[0],(int)Sub34.Deg_Order[1]);
			
		
		for(i=0;i<strlen(buf2);i++){
			def2[0]=buf2[i];
			ret=write(SH2,def2,sizeof(def2));
			if (ret == -1) {
				printf("ERROR\n\r");
			}
		}
	
		usleep(15000); 
		memset(&buf2, 0, sizeof(buf2));
		ret=read(SH2, buf2,80);
		if (ret == -1) {
			printf("ERROR\n\r");
		}else{
		//	printf("www\n\r");
		//s[20:-20][FFA:1DD0][0.015:2.908][2.043:1.241]e
			sscanf(buf2,"s[%X:%X][%f:%f][%f:%f]e"
			
			,&Sub34.ENC[0],&Sub34.ENC[1],
			&Sub34.Verocity_MD[1],&Sub34.Load[1],
			&Sub34.Verocity_MD[0],&Sub34.Load[0]);
			Sub34.Load[0]=-1*(Sub34.Load[0]-2)*7/2;
			Sub34.Load[1]=-1*(Sub34.Load[1]-2)*7/2;
			
			if(DegLoopF==1){
			
				Sub34.DEF_ENC[0]=Sub34.ENC[0]-Sub34.OLD_ENC[0];
			
				if(Sub34.DEF_ENC[0] <= -50000){
					Sub34.DEF_ENC[0]=Sub34.ENC[0]+65535-Sub34.OLD_ENC[0];
				}		
				if(Sub34.DEF_ENC[0] >= 50000){
					Sub34.DEF_ENC[0]=Sub34.ENC[0]-65535-Sub34.OLD_ENC[0];
				}
			
			
				Sub34.DEF_ENC[1]=Sub34.ENC[1]-Sub34.OLD_ENC[1];
			
				if(Sub34.DEF_ENC[1] <= -50000){
					Sub34.DEF_ENC[1]=Sub34.ENC[1]+65535-Sub34.OLD_ENC[1];
				}		
				if(Sub34.DEF_ENC[1] >= 50000){
					Sub34.DEF_ENC[1]=Sub34.ENC[1]-65535-Sub34.OLD_ENC[1];
				}
		
		
		
		
			//	Sub34.DEF_Deg[0]=Sub34.DEF_ENC[0]*0.000168;
			//	Sub34.Deg[0] += Sub34.DEF_Deg[0];//1:2090 モータ1回転256パルス
				//printf("%d \n\r",Sub34.ENC[0]);
				//printf("%d= %d - %d\n\r",Sub34.DEF_ENC[0],Sub34.ENC[0],Sub34.OLD_ENC[0]);
				//printf("%f +=%f",Sub34.Deg[0] ,Sub34.DEF_Deg[0]);
			//	Sub34.OLD_ENC[0]=Sub34.ENC[0];
		
				Sub34.DEF_Deg[0]=Sub34.DEF_ENC[0]*0.000168;
				Sub34.Deg[0] -= Sub34.DEF_Deg[0];//1:2090 モータ1回転256パルス
		
				Sub34.DEF_Deg[1]=Sub34.DEF_ENC[1]*0.000168;
				Sub34.Deg[1] -= Sub34.DEF_Deg[1];//1:2090 モータ1回転256パルス
				printf("LOAD1:%f LOAD1:%f \n\r",Sub34.Load[0],Sub34.Load[1]);
		      		Sub34.w[0]=(Sub34.DEF_Deg[0]*2*M_PI/(256*4))/dt*1000*degree;
				Sub34.w[1]=(Sub34.DEF_Deg[1]*2*M_PI/(256*4))/dt*1000*degree;
				Robot.Sub_w[0]=Sub34.w[0]*0.00287;
				Robot.Sub_w[1]=Sub34.w[1]*0.00287;
			//printf("%d \n\r",Sub34.ENC[0]);
			//printf("%d= %d - %d\n\r",Sub34.DEF_ENC[0],Sub34.ENC[0],Sub34.OLD_ENC[0]);
			//printf("%f +=%f",Sub34.Deg[0] ,Sub34.DEF_Deg[0]);
			}
			Sub34.OLD_ENC[0]=Sub34.ENC[0];
			Sub34.OLD_ENC[1]=Sub34.ENC[1];
			DegLoopF=1;
		}
	
	
	}		
	close(SH2);
//
//SH-3 Sub Motor
//	Sub56

  Connect_serial(3);
	if(SH_OK_FLG[2]==1){
	
		memset(&buf3, 0, sizeof(buf3));
		memset(&def3, 0, sizeof(def3));
	//
	//指令値生成 from MOT
	//
		Sub56.Deg_Order[0]= (int)m_MOT_Sub.data[2];
		Sub56.Deg_Order[1]= (int)m_MOT_Sub.data[3];
		if(m_Mode.data[3]==1||Sub_LOCK[2]==1||Sub_LOCK[3]==1){
			if(m_Sub_Angle.data[2]!=555|| (Sub_LOCK[2]==1)){
				if(m_Sub_Angle.data[2]!=555){			
				        Sub56.Deg_T[0]=m_Sub_Angle.data[2];
				}
				Sub_LOCK[2]=1;
				Sub_ANG(2,Sub56.Deg_T[0]);
			}else{
			//	Sub_LOCK[0]=0;
			}

			if(m_Sub_Angle.data[3]!=555|| (Sub_LOCK[3]==1)){
			        if(m_Sub_Angle.data[3]!=555){			
				        Sub56.Deg_T[1]=m_Sub_Angle.data[3];
				}
				Sub_LOCK[3]=1;
				Sub_ANG(3,Sub56.Deg_T[1]);
				
			}else{			
			//	Sub_LOCK[1]=0;
			}

		//	std::cout<<"sL3:"<<Sub_LOCK[2]<<"sL4:"<<Sub_LOCK[3]<<std::endl;
		}
		
		

	//	std::cout<<"s3:"<<Sub56.Deg_Order[0]<<"s4:"<<Sub56.Deg_Order[1]<<std::endl;
		sprintf(buf3,"s%d:%de",(int)Sub56.Deg_Order[0],(int)Sub56.Deg_Order[1]);
			
	//	sprintf(buf3,"s%d:%de",(int)m_MOT_Sub.data[2]*9/3,(int)m_MOT_Sub.data[3]*9/3);
		for(i=0;i<strlen(buf3);i++){
			def3[0]=buf3[i];
			ret=write(SH3,def3,sizeof(def3));
			if (ret == -1) {
				printf("ERROR\n\r");
			}
		}
	
		usleep(15000); 
		memset(&buf3, 0, sizeof(buf3));
		ret=read(SH3, buf3,80);
		if (ret == -1) {
			printf("ERROR\n\r");
		}else{
		//	printf("www\n\r");
		//s[20:-20][FFA:1DD0][0.015:2.908][2.043:1.241]e
			sscanf(buf3,"s[%X:%X][%f:%f][%f:%f]e"
			,&Sub56.ENC[0],&Sub56.ENC[1],
			&Sub56.Verocity_MD[1],&Sub56.Load[1],
			&Sub56.Verocity_MD[0],&Sub56.Load[0]);
			Sub56.Load[0]=(Sub56.Load[0]-2)*7/2;
			Sub56.Load[1]=(Sub56.Load[1]-2)*7/2;
			
			if( DegLoopR==1){
		
				Sub56.DEF_ENC[0]=Sub56.ENC[0]-Sub56.OLD_ENC[0];
			
				if(Sub56.DEF_ENC[0] <= -50000){
					Sub56.DEF_ENC[0]=Sub56.ENC[0]+65535-Sub56.OLD_ENC[0];
				}		
				if(Sub56.DEF_ENC[0] >= 50000){
					Sub56.DEF_ENC[0]=Sub56.ENC[0]-65535-Sub56.OLD_ENC[0];
				}
			
				Sub56.DEF_ENC[1]=Sub56.ENC[1]-Sub56.OLD_ENC[1];
			
				if(Sub56.DEF_ENC[1] <= -50000){
					Sub56.DEF_ENC[1]=Sub56.ENC[1]+65535-Sub56.OLD_ENC[1];
				}		
				if(Sub56.DEF_ENC[1] >= 50000){
					Sub56.DEF_ENC[1]=Sub56.ENC[1]-65535-Sub56.OLD_ENC[1];
				}
		
		
				Sub56.DEF_Deg[0]=Sub56.DEF_ENC[0]*0.000168;
				Sub56.Deg[0] += Sub56.DEF_Deg[0];//1:2090 モータ1回転256パルス
			
				Sub56.DEF_Deg[1]=Sub56.DEF_ENC[1]*0.000168;
				Sub56.Deg[1] += Sub56.DEF_Deg[1];//1:2090 モータ1回転256パルス
				
				
		      		Sub56.w[0]=(Sub56.DEF_Deg[0]*2*M_PI/(256*4))/dt*1000*degree;
				Sub56.w[1]=(Sub56.DEF_Deg[1]*2*M_PI/(256*4))/dt*1000*degree;
			//	printf("%d \n\r",Sub56.ENC[0]);
			//	printf("%d= %d - %d\n\r",Sub56.DEF_ENC[0],Sub56.ENC[0],Sub56.OLD_ENC[0]);
			//	printf("%f +=%f",Sub56.Deg[0] ,Sub56.DEF_Deg[0]);
				}
			Sub56.OLD_ENC[0]=Sub56.ENC[0];
			Sub56.OLD_ENC[1]=Sub56.ENC[1];
			Robot.Sub_w[2]=Sub56.w[0]*0.00287;
			Robot.Sub_w[3]=Sub56.w[1]*0.00287;
			 DegLoopR=1;
		}
	/*
	
		Sub56.DEF_Deg[0]=Sub56.DEF_ENC[0]*0.000168;
		Sub56.Deg[0] += Sub56.DEF_Deg[0];//1:2090 モータ1回転256パルス
		//printf("%d \n\r",Sub56.ENC[0]);
		//printf("%d= %d - %d\n\r",Sub56.DEF_ENC[0],Sub56.ENC[0],Sub56.OLD_ENC[0]);
		//printf("%f +=%f",Sub56.Deg[0] ,Sub56.DEF_Deg[0]);
		Sub56.OLD_ENC[0]=Sub56.ENC[0];
	*/
	}
	close(SH3);
	
	Status();
	
	m_Sub_Angle_Out.data[0] = Sub34.Deg[0];
	m_Sub_Angle_Out.data[1] = Sub34.Deg[1];
	m_Sub_Angle_Out.data[2] = Sub56.Deg[0];
	m_Sub_Angle_Out.data[3] = Sub56.Deg[1];
	m_Sub_Angle_OutOut.write();
	
	m_Load.data[0]=Main12.Load[0];
	m_Load.data[1]=Main12.Load[1];
	m_Load.data[2]=Sub34.Load[0];
	m_Load.data[3]=Sub34.Load[1];
	m_Load.data[4]=Sub56.Load[0];
	m_Load.data[5]=Sub56.Load[1];
	m_LoadOut.write();

}

//
  gettimeofday(&ti, NULL);
  t0=(double)(ti.tv_sec)+(double)(ti.tv_usec)*0.001*0.001;
  
  dt=t0-t1;
  printf("⊿ t:%lf\n\r",dt);
  printf("\x1b[0J");
  
  gettimeofday(&ti, NULL);
  t1=(double)(ti.tv_sec)+(double)(ti.tv_usec)*0.001*0.001;
  if(FirstLoop!=1){
  	sum_t+=dt;
 	Logger();
  }
  FirstLoop=0;
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E2_Crawler::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t  RTC_E2_Crawler::Connect_serial(int sh_num){
	//cha PORT=m_SH1_PORT;
        int ret,i=0;
        int ERR_FLG=0;
	int p_len;
	char* portname;
	struct termios SH; 
	
	
	if(sh_num==1){
	      ///  printf("SH1");
//
//m_SH1_PORTをstringからcharへ
//                     portnameに格納
//m_SH1_PORT コンフィギュレーションパラメータより
//                     /dev/ttyUSBX X=0,1,2...の形
//
	p_len=m_SH1_PORT.length();
	portname=new char[p_len+1];
	memcpy(portname, m_SH1_PORT.c_str(), p_len+1);
	
	
	
//SH1devPATH:portname   O_RDWR:読み書きモードでopen
	SH1=open(portname, O_RDWR);



	//std::cout<<portname <<std::endl;	
	
	ret = tcgetattr(SH1, &SH1_ter);
	ret = tcsetattr(SH1, TCSANOW, &SH1_ter);
	if (ret){
			printf("ERR tcsetattr\n\r");
			ERR_FLG=1;
		}
	memset(&SH, 0, sizeof(SH));
//
//c_cflag controlmode
//BAUDRATE3->SH1の通信速度
//     BAUDRATE コンフィギュレーションパラメータより
//           9600,19200,38400,57600の４択
// CRTSCTS ハードウェアフロー制御ON
// CS88bit Non-paritystopbit 1
// CLOCAL  Local接続
// CREAD受信文字有効化
//
	        if(m_BAUDRATE1.compare("B9600")==0){
	        	SH.c_cflag =(B9600 | CRTSCTS | CS8 | CLOCAL | CREAD);
		//        std::cout<<"Baudrate B9600" <<std::endl;	
	        }else if(m_BAUDRATE1.compare("B19200")==0){
	        	SH.c_cflag =(B19200 | CRTSCTS | CS8 | CLOCAL | CREAD);
		//        std::cout<<"Baudrate B19200" <<std::endl;	
	        }else if(m_BAUDRATE1.compare("B38400")==0){
	        	SH.c_cflag =(B38400 | CRTSCTS | CS8 | CLOCAL | CREAD);
		 //       std::cout<<"Baudrate B38400" <<std::endl;	
	        }else if(m_BAUDRATE1.compare("B57600")==0){
	        	SH.c_cflag =(B57600 | CRTSCTS | CS8 | CLOCAL | CREAD);
		 //       std::cout<<"Baudrate B57600" <<std::endl;	
	        }else{
		        std::cout<<"Baudrate ERR" <<std::endl;	
	        }	       
//
//c_iflag   inputmode
// IGNPAR  Parityエラー無視
// ICRNL入力のCR→NLに置き換え
//
		SH.c_iflag = (IGNPAR | ICRNL);//IGNBRK | IGNPAR;if (ret < 0)
		//printf("ERR");
	     //   cfsetispeed(&tio, m_BAUDRATE1);
		ret = tcflush(SH1, TCIFLUSH);
	
		if (ret < 0){
			printf("ERR tcflush\n\r");
			ERR_FLG=1;
		}
		//   .// exitfail_errno("tcflush");

	 
		ret = tcsetattr(SH1, TCSANOW, &SH);
		if (ret){
			printf("ERR tcsetattr\n\r");
			ERR_FLG=1;
		}
		
		if(ERR_FLG!=1){
			//printf("OK!\n\r");
			SH_OK_FLG[0]=1;
		}
		else{
			SH_OK_FLG[0]=0;
		}
		
        }else if(sh_num==2){
        	//printf("SH2");
//
//m_SH2_PORTをstringからcharへ
//                     portnameに格納
//m_SH2_PORT コンフィギュレーションパラメータより
//                     /dev/ttyUSBX X=0,1,2...の形
//
        	p_len=m_SH2_PORT.length();
        	portname=new char[p_len+1];
 		memcpy(portname, m_SH2_PORT.c_str(), p_len+1);
	
//SH2devPATH:portname   O_RDWR:読み書きモードでopen
	        SH2=open(portname, O_RDWR);
	        //std::cout<<portname <<std::endl;	
	        ret = tcgetattr(SH2, &SH2_ter);
	        ret = tcsetattr(SH2, TCSANOW, &SH2_ter);
		if (ret){
			printf("ERR tcsetattr\n\r");
			ERR_FLG=1;
		}
		memset(&SH, 0, sizeof(SH));
//
//
//c_cflag controlmode
//BAUDRATE2->SH2の通信速度
//     BAUDRATE コンフィギュレーションパラメータより
//           9600,19200,38400,57600の４択
// CRTSCTS ハードウェアフロー制御ON
// CS88bit Non-paritystopbit 1
// CLOCAL  Local接続
// CREAD受信文字有効化
//
	        if(m_BAUDRATE2.compare("B9600")==0){
	        	SH.c_cflag =(B9600 | CRTSCTS | CS8 | CLOCAL | CREAD);
		//        std::cout<<"Baudrate B9600" <<std::endl;	
	        }else if(m_BAUDRATE2.compare("B19200")==0){
	        	SH.c_cflag =(B19200 | CRTSCTS | CS8 | CLOCAL | CREAD);
		//        std::cout<<"Baudrate B19200" <<std::endl;	
	        }else if(m_BAUDRATE2.compare("B38400")==0){
	        	SH.c_cflag =(B38400 | CRTSCTS | CS8 | CLOCAL | CREAD);
		//        std::cout<<"Baudrate B38400" <<std::endl;	
	        }else if(m_BAUDRATE2.compare("B57600")==0){
	        	SH.c_cflag =(B57600 | CRTSCTS | CS8 | CLOCAL | CREAD);
		//        std::cout<<"Baudrate B57600" <<std::endl;	
	        }else{
		        std::cout<<"Baudrate ERR" <<std::endl;	
	        }	        
//
//c_iflag   inputmode
// IGNPAR  Parityエラー無視
// ICRNL入力のCR→NLに置き換え
//
		SH.c_iflag = (IGNPAR | ICRNL);//IGNBRK | IGNPAR;if (ret < 0)
		//printf("ERR");
	     //   cfsetispeed(&tio, m_BAUDRATE1);
		ret = tcflush(SH1, TCIFLUSH);
	
		if (ret < 0){
			printf("ERR tcflush\n\r");
			ERR_FLG=1;
		}
		//   .// exitfail_errno("tcflush");

	 
		ret = tcsetattr(SH1, TCSANOW, &SH);
		if (ret){
			printf("ERR tcsetattr\n\r");
			ERR_FLG=1;
		}
		
		
		if(ERR_FLG!=1){
		//	printf("OK!\n\r");
			SH_OK_FLG[1]=1;
		}
		else{
			SH_OK_FLG[1]=0;
		}
		
        }else if(sh_num==3){
        	//printf("SH3");
//
//m_SH3_PORTをstringからcharへ
//                     portnameに格納
//m_SH3_PORT コンフィギュレーションパラメータより
//                     /dev/ttyUSBX X=0,1,2...の形
//
        	p_len=m_SH3_PORT.length();
        	portname=new char[p_len+1];
 		memcpy(portname, m_SH3_PORT.c_str(), p_len+1);
	
//SH3devPATH:portname   O_RDWR:読み書きモードでopen
	        SH3=open(portname, O_RDWR);
	        //std::cout<<portname <<std::endl;	
	        ret = tcgetattr(SH3, &SH3_ter);
	        ret = tcsetattr(SH3, TCSANOW, &SH3_ter);
	        if (ret){
			printf("ERR tcsetattr\n\r");
			ERR_FLG=1;
		}
		
		memset(&SH, 0, sizeof(SH));

//
//c_cflag controlmode
//BAUDRATE3->SH3の通信速度
//     BAUDRATE コンフィギュレーションパラメータより
//           9600,19200,38400,57600の４択
// CRTSCTS ハードウェアフロー制御ON
// CS88bit Non-paritystopbit 1
// CLOCAL  Local接続
// CREAD受信文字有効化
//
	        if(m_BAUDRATE3.compare("B9600")==0){
	        	SH.c_cflag =(B9600 | CRTSCTS | CS8 | CLOCAL | CREAD);
		//        std::cout<<"Baudrate B9600" <<std::endl;	
	        }else if(m_BAUDRATE3.compare("B19200")==0){
	        	SH.c_cflag =(B19200 | CRTSCTS | CS8 | CLOCAL | CREAD);
		//        std::cout<<"Baudrate B19200" <<std::endl;	
	        }else if(m_BAUDRATE3.compare("B38400")==0){
	        	SH.c_cflag =(B38400 | CRTSCTS | CS8 | CLOCAL | CREAD);
		//        std::cout<<"Baudrate B38400" <<std::endl;	
	        }else if(m_BAUDRATE3.compare("B57600")==0){
	        	SH.c_cflag =(B57600 | CRTSCTS | CS8 | CLOCAL | CREAD);
		//        std::cout<<"Baudrate B57600" <<std::endl;	
	        }else{
		        std::cout<<"Baudrate ERR" <<std::endl;	
	        }
//
//c_iflag   inputmode
// IGNPAR  Parityエラー無視
// ICRNL入力のCR→NLに置き換え
//
		SH.c_iflag = (IGNPAR | ICRNL);//IGNBRK | IGNPAR;if (ret < 0)
		//printf("ERR");
	     //   cfsetispeed(&tio, m_BAUDRATE1);
		ret = tcflush(SH1, TCIFLUSH);
	
		if (ret < 0){
			printf("ERR tcflush\n\r");
			ERR_FLG=1;
		}
		//   .// exitfail_errno("tcflush");

	 
		ret = tcsetattr(SH1, TCSANOW, &SH);
		if (ret){
			printf("ERR tcsetattr\n\r");
			ERR_FLG=1;
		}
		if(ERR_FLG!=1){
			//printf("OK!\n\r");
			SH_OK_FLG[2]=1;
		}
		else{
			SH_OK_FLG[2]=0;
		}
		
        }else{
        }
                
  return RTC::RTC_OK;
}




RTC::ReturnCode_t RTC_E2_Crawler:: Status(){
  char str[256];
  std::cerr<<"\x1b[1m" <<"\x1b[36m" << "Sub34" <<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
  std::cerr<<"\x1b[1m" <<"\x1b[36m" << Sub34.Deg[0] <<":"<< Sub34.Deg[1] <<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
  std::cerr<<"\x1b[1m" <<"\x1b[34m" << "Sub56" <<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
  std::cerr<<"\x1b[1m" <<"\x1b[34m" << Sub56.Deg[0] <<":"<< Sub56.Deg[1]<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
  ofstream STout( "Status.txt", ios::trunc );
  STout << Sub34.Deg[0] <<":" << Sub34.Deg[1]<<":" <<Sub56.Deg[0] <<":"<< Sub56.Deg[1]  << endl;
  return RTC::RTC_OK;
}

//
//Sub
//  int id  サブふりっぱ位置0:前右 1:前左 2:後右 3:後左
//double DEG_T 目標角

RTC::ReturnCode_t RTC_E2_Crawler:: Sub_ANG(int id , double DEG_T){
  long DEG_E;
  long E;
  double kp=4.4;
  double ki=0.5;
  double kd=0.002;
  double DEF_DEG_T=0;
  if(id==0||id==1){
	  DEF_DEG_T=DEG_T-Sub34.Deg[id];
	  std::cerr<<"\x1b[1m" <<"\x1b[36m" <<"ANG_def:"<< DEF_DEG_T<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
  
	  Sub34.Deg_Order[id]=-kp*DEF_DEG_T-kd*Sub34.Old_deg[id]/dt;
	  
	  if(Sub34.Deg_Order[id]<12 &&Sub34.Deg_Order[id]>0)Sub34.Deg_Order[id]=12;
	  if(Sub34.Deg_Order[id]>-12 &&Sub34.Deg_Order[id]<0)Sub34.Deg_Order[id]=-12;
	  if(Sub34.Deg_Order[id]>50 )Sub34.Deg_Order[id]=50;
	  if(Sub34.Deg_Order[id]<-50)Sub34.Deg_Order[id]=-50;

	  Sub34.Old_deg[id]=Sub34.Deg[id];
  }
  if(id==2||id==3){
	  DEF_DEG_T=DEG_T-Sub56.Deg[id-2];
	  Sub56.Deg_Order[id-2]=kp*DEF_DEG_T+kd*Sub56.Old_deg[id-2]/dt;
	  if(Sub56.Deg_Order[id-2]<12 &&Sub56.Deg_Order[id-2]>0)Sub56.Deg_Order[id-2]=12;
	  if(Sub56.Deg_Order[id-2]>-12 &&Sub56.Deg_Order[id-2]<0)Sub56.Deg_Order[id-2]=-12;
	  if(Sub56.Deg_Order[id-2]>50 )Sub56.Deg_Order[id-2]=50;
	  if(Sub56.Deg_Order[id-2]<-50)Sub56.Deg_Order[id-2]=-50;
	  
	  Sub56.Old_deg[id-2]=Sub56.Deg[id-2]; 
  }
  
  
  if(id==0||id==1)
	  std::cerr<<"\x1b[1m" <<"\x1b[36m" <<"ANG:"<< Sub34.Deg[id] <<"ANG_O:"<< Sub34.Deg_Order[id] <<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
  
  if(id==2||id==3) 
  	   std::cerr<<"\x1b[1m" <<"\x1b[36m" <<"ANG:"<< Sub56.Deg[id-2] <<"ANG_O:"<< Sub56.Deg_Order[id-2] <<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
  
  
  
  if(fabs(DEF_DEG_T)<0.05) Sub_LOCK[id] =0;
//    Sub34.Deg_Order[id];    
  
  
  
  return RTC::RTC_OK;
}

RTC::ReturnCode_t RTC_E2_Crawler:: Logger(){
  char f1[100]="";
  char f2[100]="";
  Logout_M << sum_t 
  <<"\t"<< Main12.Velocity[0]<<"\t" << Main12.Velocity[1]
  <<"\t" << Sub34.Deg[0]<<"\t" << Sub34.Deg[1]<<"\t" <<Sub56.Deg[0] <<"\t"<< Sub56.Deg[1] 
   << "\t" << Main12.Load[0]  << "\t" << Main12.Load[1]  
 << "\t" << Sub34.Load[0]  << "\t" << Sub34.Load[1]  
 << "\t" << Sub56.Load[0]  << "\t" << Sub56.Load[1]   
   << "\t" <<dt<<endl;
  sprintf(f1,"%.3lf",Robot.Vx_Order);
  sprintf(f2,"%.3lf",Robot.Vx);
  
  Logout_V << sum_t 
  <<"\t"<< Main12.Velocity_Order[0]<<"\t" << Main12.Velocity[0]
  <<"\t"<< Main12.Velocity_Order[1]  <<"\t" << Main12.Velocity[1]  
  <<  "\t" << Robot.Vx_Order  <<  "\t"   << Robot.Vx  <<  "\t" << Robot.Va_Order  <<  "\t" << Robot.Va 
    //<< Main12.PWM_Order[0]  <<  "\t" << Main12.PWM[0]  <<  "\t" << Main12.PWM_Order[1] 
   //  <<  "\t"    << f1  << "\t" << f2 <<
      <<"\t" << Main12.Load[0]  << "\t" << Main12.Load[1]  << "\t"
    <<dt<< endl;
 
  
  Logout_D << sum_t <<"\t"<< Sub34.Deg_T[0]<<"\t"<< Sub34.Deg[0]<<"\t"<< Sub34.Deg_T[1]<<"\t"<< Sub34.Deg[1]
  <<"\t"<< Sub56.Deg_T[0]<<"\t"<< Sub56.Deg[0]<<"\t"<< Sub56.Deg_T[1]<<"\t"<< Sub56.Deg[1]
  <<"\t" <<Sub34.w[0]  <<"\t"<< Sub34.w[1]  <<"\t"<< Sub56.w[0] <<"\t"<< Sub56.w[1]  
  //<<"\t"<< Robot.Sub_w[0]  <<"\t"<< Robot.Sub_w[1] <<"\t"<< Robot.Sub_w[3] <<"\t"<< Robot.Sub_w[4] 
   <<  "\t"<<
  Sub34.Load[0]  <<"\t"<<  Sub34.Load[1] <<"\t"<<  Sub56.Load[0] <<"\t"<< Sub56.Load[1]  <<  "\t" <<dt<< endl;
  //<< Sub34.Deg[0]<<"\t"<< Sub34.Deg[1]<<"\t" <<Sub56.Deg[0] <<"\t"<< Sub56.Deg[1] <<"\t"
  
  Logout_O<<sum_t
  <<"\t"<<Robot.X<<"\t"<<Robot.Y<<"\t" <<Robot.Z
  <<"\t" << Robot.Roll*degree<<"\t" << Robot.Pitch*degree<<"\t" <<Robot.Yaw*degree
 // <<"\t"<<Robot.X2<<"\t"<<Robot.Y2
  <<"\t"<< endl;
  return RTC::RTC_OK;

}
void Log_init(){

	
	Logout_M<<"TIME"<<"\t"<< "Main_Right_Velocity"<<"\t" << "Main_Left_Velocity_Order" 
	 <<"\t"<< "Sub34.Deg[0]"<<"\t"<<" Sub34.Deg[1]"<<"\t"<< "Sub56.Deg[0]"<<"\t"<<" Sub56.Deg[1]"
	  << "\t" << "Main12.Load[0]"  << "\t" << "Main12.Load[1]"   
	 << "\t" << "Sub34.Load[0]"  << "\t" << "Sub34.Load[1]"  
	 << "\t" << "Sub56.Load[0]"  << "\t" << "Sub56.Load[1]"   
	 << "\t"<<"dt"<< endl;
	 
	Logout_V<<"TIME"<<"\t"<< "Main_Right_Velocity_Order"<<"\t" << "Main_Right_Velocity"<<"\t"<< "Main_Left_Velocity_Order"<<"\t" << "Main_Left_Velocity_Order" 
	 <<  "\t" <<" Robot.Vx_Order"  <<  "\t" << "Robot.Vx " <<  "\t" << "Robot.Va_Order"  <<  "\t" << "Robot.Va"  
	// <<  "\t" << "Main12.PWM_Order[0]"  <<  "\t" << "Main12.PWM[0]"  <<  "\t" << "Main12.PWM_Order[1]"  <<  "\t" << "Main12.PWM_Order[1]"  
	// <<  "\t" << "V1"  << "\t" <<"V2"
	 << "\t" << "Main12.Load[0]"  << "\t" << "Main12.Load[1]"  << "\t"<<"dt"<< endl;
	 
	//Logout_V << "0 "<<"\t"<< "0"<<"\t" << "0"<<"\t"<< "0"<<"\t" << "0"  <<  "\t" <<"0"  <<  "\t" << "0" <<  "\t" << "0"  <<  "\t" << "0"  <<  "\t" << "0"  <<  "\t" << "0"  <<  "\t" << "0" <<  "\t" <<"0"  <<  "\t" << "0"  << "\t" <<"0"<< "\t" << "0"  << "\t" << "0"  << "\t"<<"0"<< endl;

	Logout_D << "TIME" 
	<<"\t"<< "Sub34.Deg_Order[0]"<<"\t"<< "Sub34.Deg[0]"<<"\t"<<" Sub34.Deg_Order[1]"<<"\t"<<" Sub34.Deg[1]"
	<<"\t"<<" Sub56.Deg_Order[0]"<<"\t"<< "Sub56.Deg[0]"<<"\t"<<" Sub56.Deg_Order[1]"<<"\t"<<" Sub56.Deg[1]"
 	<<"\t" <<"Sub34.w[0]"  <<"\t"<<" Sub34.w[1]  "<<"\t"<<" Sub56.w[0] "<<"\t"<<" Sub56.w[1] " 
//	<<"\t"<<" Robot.Sub_w[0]"  <<"\t"<< "Robot.Sub_w[1]"<<"\t"<< "Robot.Sub_w[3]" <<"\t"<<" Robot.Sub_w[4]"
	 << "\t"<<"Sub34.Load[0]"  <<"\t"<<  "Sub34.Load[1] "<<"\t"<<  "Sub56.Load[0]" <<"\t"<< "Sub56.Load[1]"  
	<<"\t"<<"dt"<< endl;
	Logout_O<<"TIME"<<"\t"<< "X"<<"\t" << "Y"<<"\t" << "Z"<<"\t" << "Roll"<<"\t" << "Pitch"<<"\t" << "Yaw"<< endl;
}


extern "C"
{
 
  void RTC_E2_CrawlerInit(RTC::Manager* manager)
  {
    coil::Properties profile(rtc_e2_crawler_spec);
    manager->registerFactory(profile,
                             RTC::Create<RTC_E2_Crawler>,
                             RTC::Delete<RTC_E2_Crawler>);
  }
  
};


